using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Net.Sockets;

namespace Simple_QuakeWars_Rcon
{
    class Program
    {
        static void Main(string[] args)
        {
            if (args.Length < 2)
            {
                Console.WriteLine("Simple QuakeWars Rcon 0.1  Copyright (C) 2007  Mathias Zander");
                Console.WriteLine("visit www.mathias-zander.de\n");
                Console.WriteLine("This program comes with ABSOLUTELY NO WARRANTY");
                Console.WriteLine("This is free software, and you are welcome to redistribute it");
                Console.WriteLine("under certain conditions; See the GNU General Public License");
                Console.WriteLine("for more details.\n");
                Console.WriteLine("Usage:");
                Console.WriteLine("sqwr.exe -ip <ip address> -port <port> -pw <rcon password> <rcon command>");
                return;
            }

            string host = string.Empty;
            int port = 27733;
            IPAddress ip = IPAddress.Parse("127.0.0.1");
            string rconPw = string.Empty;
            string command = string.Empty;
            string receiveString = string.Empty;
            int param = 0;
            //prase command line arguments
            for (int index = 0; index < args.Length; index++)
            {
                if (args[index].Equals("-ip"))
                {
                    if (!IPAddress.TryParse(args[++index], out ip))
                    {
                        Console.WriteLine("ip address error");
                        return;
                    }
                    param++;
                }
                if (args[index].Equals("-port"))
                {
                    if (!int.TryParse(args[++index], out port))
                    {
                        Console.WriteLine("port error");
                        return;
                    }
                    param++;
                }
                if (args[index].Equals("-pw"))
                {
                    rconPw = args[++index];
                    param++;
                }
            }
            for (int i = param * 2; i < args.Length; i++)
            {
                command += args[i] + " ";
            }
            //use udpClient to send command and receive answer 
            UdpClient udpClient = new UdpClient(0);
            try
            {
                udpClient.Connect(ip, port);
                udpClient.Client.ReceiveTimeout = 1000;
                Byte[] sendBytes = System.Text.Encoding.Default.GetBytes("rcon" + rconPw + "" + command + ""); //this could give trouble with some languages
                udpClient.Send(sendBytes, sendBytes.Length);
                IPEndPoint RemoteIpEndPoint = new IPEndPoint(IPAddress.Any, 0);
                Byte[] receiveBytes = udpClient.Receive(ref RemoteIpEndPoint);
                receiveString = System.Text.Encoding.Default.GetString(receiveBytes);
                receiveString = receiveString.Remove(0, 12);
                udpClient.Close();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                udpClient.Close();
            }
            Console.WriteLine(receiveString);
        }
    }
}
